//===================================================================
// Apci9131s.pas -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// Po (tB^O) s܂
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
unit Apci9131s;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci9131w;

const
	szTitle	= 'Sample';

type
	TMainForm = class(TForm)
		procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
	private
		{ Private 錾 }
  	wBsn:	WORD;

    procedure RegInit( Sender: TObject );
	public
		{ Public 錾 }
		procedure ResultMessage( strbuf: String );
		procedure ErrorMessage( bsn: WORD );
	end;

var
	MainForm: TMainForm;

implementation

{$R *.DFM}

//===================================================================
// vOJn
//===================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	Ri:				APCI9131RESOURCE; // \[X
	dwDllVer: DWORD;						// DLL o[W
	dwDrvVer: DWORD;						// Driver o[W
	bSwVal:   BYTE;             // BSN l
	bCnt:			BYTE;							// tB^^CWX^ݒl
	bData:		BYTE;							// o͒l
	szBuf:		String;
begin
	wBsn := APCI9131_BSN_AUTO;
	//-----------------------------------------------------------------
	// DLL gp錾
	//-----------------------------------------------------------------
	if Apci9131wDllOpen() = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;											// DLL [hs
	end;
  ResultMessage( 'DLL [h܂' );
	//-----------------------------------------------------------------
	// o[W擾
	//-----------------------------------------------------------------
	if Apci9131wGetVersion( dwDllVer, dwDrvVer ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	szBuf := Format( 'GetVersion'#10 +
									 'DLL Version'#09 + ': %0.8xH'#10 +
									 'Driver Version'#09 + ': %0.8xH',
									 [ dwDllVer, dwDrvVer ] );
	ResultMessage( szBuf );
	//-----------------------------------------------------------------
	// foCXgp錾
	//-----------------------------------------------------------------
	if Apci9131wCreate( wBsn, 0, 0 ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	ResultMessage( 'aPCI-9131 Create' );
	//-----------------------------------------------------------------
	// \[X BSN l擾
	//-----------------------------------------------------------------
	if Apci9131wGetResource( wBsn, @Ri ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	if Apci9131wGetSwitchValue( wBsn, bSwVal ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	szBuf := Format( 'APIC21 I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
                   'Device I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
                   'IRQ Number'#09 + ': %0.2d'#10 +
									 'BSN Value'#09 + ': %0.2xH',
									 [ Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
                     Ri.dwIoBase[ 2 ], Ri.dwIoBase[ 2 ] + Ri.dwIoLength[ 2 ] - 1,
										 Ri.dwIrq, bSwVal ] );
	ResultMessage( szBuf );
 	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
  RegInit( nil );
	//-----------------------------------------------------------------
	// |[g1 ̃`^OtB^ݒ
	//-----------------------------------------------------------------
	bCnt := 0;
	if Apci9131wSetFilter( wBsn, APCI9131_F_PORT1, bCnt ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
  szBuf := Format( '|[g1 ̃`^OtB^ݒ肵܂'#10 +
                   'tB^ : %ds',
                   [ bCnt * 10 ] );
	ResultMessage( szBuf );
	//-----------------------------------------------------------------
	// |[g1 Ƀf[^
	//-----------------------------------------------------------------
	bData := $AA;
	if Apci9131wOutportb( wBsn, APCI9131_PORT1, bData ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
  szBuf := Format( '|[g1 Ƀf[^݂܂'#10 +
                   'Write Data : %0.2xH',
                   [ bData ] );
	ResultMessage( szBuf );
	//-----------------------------------------------------------------
	// |[g1 f[^ǂݍ
	//-----------------------------------------------------------------
	bData := $00;
	if Apci9131wInportb( wBsn, APCI9131_PORT1, bData ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	szBuf := Format( '|[g1 f[^ǂݍ݂܂'#10 +
                   'Read Data : %0.2xH',
                   [ bData ] );
	ResultMessage( szBuf );
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	//-----------------------------------------------------------------
	// foCXgpJ
	//-----------------------------------------------------------------
	if Apci9131wClose( wBsn ) = True then
    ResultMessage( 'aPCI-9131 Close' );
	//-----------------------------------------------------------------
	// DLL gpJ
	//-----------------------------------------------------------------
	if Apci9131wDllClose() = True then
	  ResultMessage( 'DLL A[h܂' );
end;
//===================================================================
// lݒ
//===================================================================
procedure TMainForm.RegInit( Sender: TObject);
begin
	//---------------------------------------------------------------
	// o̓|[gWX^1
	//---------------------------------------------------------------
	if Apci9131wOutportb( wBsn, APCI9131_PORT1, $00 ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	//---------------------------------------------------------------
	// tB^^CWX^1 (tB^ OFF)
	//---------------------------------------------------------------
	if Apci9131wSetFilter( wBsn, APCI9131_F_PORT1, $00 ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage( strbuf: String );
begin
	Application.MessageBox( PChar( strbuf ), szTitle, MB_OK + MB_ICONINFORMATION );
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage( bsn: WORD );
var
	dwRes:	DWORD;
	szBuf: String;
begin
	dwRes := Apci9131wGetLastError( bsn );

	if dwRes = APCI9131_ERR_WRAPDLL then
    szBuf := 'DLL Load error'
  else
	  szBuf := Format( 'aPCI-9131 error'#10#10'Error code : %xH', [ dwRes ] );

	Application.MessageBox( PChar( szBuf ), szTitle, MB_OK + MB_ICONSTOP );
end;

end.
