//===================================================================
// Apci9131s.pas -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// nhVF[N[hŃ|[g1 ͂Əo͂̃[vobNs܂
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
unit Apci9131s;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci9131w;

const
	szTitle	         = 'Sample';
  WM_APCI9131      = WM_USER + 100;
  WM_APCI9131_IACK = WM_APCI9131 + APCI9131_MSG_IACK;
  WM_APCI9131_ISTB = WM_APCI9131 + APCI9131_MSG_ISTB;

type
	TMainForm = class(TForm)
		procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
	private
		{ Private 錾 }
    wBsn:    WORD;
   	szBuf:   String;
    IncData: BYTE;

    procedure DataShow( Sender: TObject );
    procedure RegInit( Sender: TObject );
	public
		{ Public 錾 }
		procedure ResultMessage( strbuf: String );
		procedure ErrorMessage( bsn: WORD );
  protected
    procedure OnAck( var Msg: TMessage ); message WM_APCI9131_IACK;
    procedure OnStb( var Msg: TMessage ); message WM_APCI9131_ISTB;
	end;

var
	MainForm: TMainForm;

implementation

{$R *.DFM}

//===================================================================
// ACK 荞ݏ
//===================================================================
procedure TMainForm.OnAck( var Msg: TMessage );
var
  bsn: WORD;
begin
  bsn := Msg.WParam;
  //-----------------------------------------------------------------
  // CNgf[^ 10 ɂȂI
  //-----------------------------------------------------------------
  if IncData < 10 then begin
    IncData := IncData + 1;
    //-----------------------------------------------------------------
    // |[g1 Ƀf[^Zbg
    //-----------------------------------------------------------------
    if Apci9131wOutportb( bsn, APCI9131_PORT1, IncData ) = False then begin
      ErrorMessage( bsn );
      Exit;
    end;
    //-----------------------------------------------------------------
    // Sleep (100ms)
    //-----------------------------------------------------------------
    Sleep( 100 );
    //-----------------------------------------------------------------
    // STB o
    //-----------------------------------------------------------------
    if Apci9131wStbOut( bsn, $01 ) = False then begin
      ErrorMessage( bsn );
      Exit;
    end;
  end else
    DataShow( nil );
end;
//===================================================================
// STB 荞ݏ
//===================================================================
procedure TMainForm.OnStb( var Msg: TMessage );
var
  bsn: WORD;
begin
  bsn := Msg.WParam;
  //-----------------------------------------------------------------
  // |[g1 ̃f[^ǂݍ
  //-----------------------------------------------------------------
  if Apci9131wInportb( bsn, APCI9131_PORT1, IncData ) = False then begin
    ErrorMessage( bsn );
    Exit;
  end;
  //-----------------------------------------------------------------
  // Sleep (100ms)
  //-----------------------------------------------------------------
  Sleep( 100 );
  //-----------------------------------------------------------------
  // ACK o
  //-----------------------------------------------------------------
  if Apci9131wAckOut( bsn, $01 ) = False then begin
    ErrorMessage( bsn );
    Exit;
  end;
end;
//===================================================================
// 
//===================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	Ri:				APCI9131RESOURCE; // \[X
	dwDllVer: DWORD;						// DLL o[W
	dwDrvVer: DWORD;						// Driver o[W
	bSwVal:   BYTE;             // BSN l
begin
  wBsn    := APCI9131_BSN_AUTO;
  IncData := 0;
	//-----------------------------------------------------------------
	// DLL gp錾
	//-----------------------------------------------------------------
	if Apci9131wDllOpen() = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;											// DLL [hs
	end;
  ResultMessage( 'DLL [h܂' );
	//-----------------------------------------------------------------
	// o[W擾
	//-----------------------------------------------------------------
	if Apci9131wGetVersion( dwDllVer, dwDrvVer ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	szBuf := Format( 'GetVersion'#10 +
									 'DLL Version'#09 + ': %0.8xH'#10 +
									 'Driver Version'#09 + ': %0.8xH',
									 [ dwDllVer, dwDrvVer ] );
	ResultMessage( szBuf );
	//-----------------------------------------------------------------
	// foCXgp錾
	//-----------------------------------------------------------------
	if Apci9131wCreate( wBsn, Handle, WM_APCI9131 ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	ResultMessage( 'aPCI-9131 Create' );
	//-----------------------------------------------------------------
	// \[X BSN l擾
	//-----------------------------------------------------------------
	if Apci9131wGetResource( wBsn, @Ri ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	if Apci9131wGetSwitchValue( wBsn, bSwVal ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	szBuf := Format( 'APIC21 I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
                   'Device I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
                   'IRQ Number'#09 + ': %0.2d'#10 +
									 'BSN Value'#09 + ': %0.2xH',
									 [ Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
                     Ri.dwIoBase[ 2 ], Ri.dwIoBase[ 2 ] + Ri.dwIoLength[ 2 ] - 1,
										 Ri.dwIrq, bSwVal ] );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
  RegInit( nil );
  //-----------------------------------------------------------------
  // ̓|[g1 ݂̂nhVF[N[hɐݒ
  //-----------------------------------------------------------------
  if Apci9131wSetStbEnableRegs( wBsn, $01 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
  ResultMessage( '̓|[g1 nhVF[N[hɐݒ肵܂');
  //-----------------------------------------------------------------
  // STB/ACK ̊荞݃Cl[u
  //-----------------------------------------------------------------
  if Apci9131wSetStbAckIr( wBsn, $11 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
  ResultMessage( 'STB/ACK ̊荞݂Lɂ܂' );
  //-----------------------------------------------------------------
  // |[g1 Ƀf[^Zbg
  //-----------------------------------------------------------------
  if Apci9131wOutportb( wBsn, APCI9131_PORT1, IncData ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
  ResultMessage( '|[g1 Ƀf[^Zbg܂' );
  //-----------------------------------------------------------------
  // STB o
  //-----------------------------------------------------------------
  if Apci9131wStbOut( wBsn, $01 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
  ResultMessage( 'STB o͂܂' );
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IncData < 10 then DataShow( nil );
  //-----------------------------------------------------------------
	// foCXgpJ
	//-----------------------------------------------------------------
	if Apci9131wClose( wBsn ) = True then
    ResultMessage( 'aPCI-9131 Close' );
	//-----------------------------------------------------------------
	// DLL gpJ
	//-----------------------------------------------------------------
	if Apci9131wDllClose() = True then
    ResultMessage( 'DLL A[h܂' );
end;
//===================================================================
// f[^\
//===================================================================
procedure TMainForm.DataShow( Sender: TObject );
begin
  //-----------------------------------------------------------------
  // STB/ACK ̊荞݃fBZ[u
  //-----------------------------------------------------------------
  if Apci9131wSetStbAckIr( wBsn, $00 ) = True then
    ResultMessage( 'STB/ACK ̊荞݂𖳌ɂ܂' );
  //-----------------------------------------------------------------
  // ̓|[g1 ̃nhVF[N[h
  //-----------------------------------------------------------------
  if Apci9131wSetStbEnableRegs( wBsn, $00 ) = True then
    ResultMessage( '̓|[g1 ̃nhVF[N[h܂' );
  //-----------------------------------------------------------------
  // CNgf[^\
  //-----------------------------------------------------------------
  szBuf := Format( 'CNgf[^ = %d', [ IncData ] );
  ResultMessage( szBuf );
end;
//===================================================================
// lݒ
//===================================================================
procedure TMainForm.RegInit( Sender: TObject );
begin
	//---------------------------------------------------------------
	// o̓|[gWX^1
	//---------------------------------------------------------------
  if Apci9131wOutportb( wBsn, APCI9131_PORT1, $00 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
	//---------------------------------------------------------------
	// STB_IN Cl[uWX^ (P̓[h)
	//---------------------------------------------------------------
  if Apci9131wSetStbEnableRegs( wBsn, $00 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
	//---------------------------------------------------------------
	// STB/ACK 荞݃Cl[uWX^ (荞݋֎~)
	//---------------------------------------------------------------
  if Apci9131wSetStbAckIr( wBsn, $00 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
	//---------------------------------------------------------------
	// STB o
	//---------------------------------------------------------------
  if Apci9131wStbOut( wBsn, $00 ) = False then begin
    ErrorMessage( wBsn );
    Halt;
  end;
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage( strbuf: String );
begin
	Application.MessageBox( PChar( strbuf ), szTitle, MB_OK + MB_ICONINFORMATION );
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage( bsn: WORD );
var
	dwRes:	DWORD;
	szBuf: String;
begin
	dwRes := Apci9131wGetLastError( bsn );

	if dwRes = APCI9131_ERR_WRAPDLL then
    szBuf := 'DLL Load error'
  else
    szBuf := Format( 'aPCI-9131 error'#10#10'Error code : %xH', [ dwRes ] );

	Application.MessageBox( PChar( szBuf ), szTitle, MB_OK + MB_ICONSTOP );
end;

end.
