//===================================================================
// Apci9131s.pas -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// ̓|[g荞݂ƃ^C}荞ݎgpł
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
unit Apci9131s;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Apci9131w;

const
	szTitle						= 'Sample';
	WM_APCI9131				= WM_USER + 100;
	WM_APCI9131_TIMER = WM_APCI9131 + APCI9131_MSG_TIMER;
	WM_APCI9131_PORT	= WM_APCI9131 + APCI9131_MSG_PORT;

type
	TMainForm = class(TForm)
		procedure FormCreate(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
	private
		{ Private 錾 }
		wBsn:			 WORD;
		szBuf:		 String;
		TimerCnt:	 DWORD;
		PortIrCnt: array[ 0..7 ] of DWORD;

    procedure DataShow( Sender: TObject );
    procedure RegInit( Sender: TObject );
	public
		{ Public 錾 }
		procedure ResultMessage( strbuf: String );
		procedure ErrorMessage( bsn: WORD );
	protected
		procedure OnTimer( var Msg: TMessage ); message WM_APCI9131_TIMER;
		procedure OnPortIr( var Msg: TMessage ); message WM_APCI9131_PORT;
	end;

var
	MainForm: TMainForm;

implementation

{$R *.DFM}

//===================================================================
// ^C}荞ݏ
//===================================================================
procedure TMainForm.OnTimer( var Msg: TMessage );
begin
  //-----------------------------------------------------------------
  // ^C}荞݉񐔂 20 ɂȂI
  //-----------------------------------------------------------------
  if TimerCnt < 20 then
  	TimerCnt := TimerCnt + 1
  else
    DataShow( nil );
end;
//===================================================================
// ̓|[g荞ݏ
//===================================================================
procedure TMainForm.OnPortIr( var Msg: TMessage );
var
	lParam: DWORD;
begin
	lParam := Msg.LParam;

	if ( lParam and $01 ) <> 0 then PortIrCnt[ 0 ] := PortIrCnt[ 0 ] + 1;
	if ( lParam and $02 ) <> 0 then PortIrCnt[ 1 ] := PortIrCnt[ 1 ] + 1;
	if ( lParam and $04 ) <> 0 then PortIrCnt[ 2 ] := PortIrCnt[ 2 ] + 1;
	if ( lParam and $08 ) <> 0 then PortIrCnt[ 3 ] := PortIrCnt[ 3 ] + 1;
	if ( lParam and $10 ) <> 0 then PortIrCnt[ 4 ] := PortIrCnt[ 4 ] + 1;
	if ( lParam and $20 ) <> 0 then PortIrCnt[ 5 ] := PortIrCnt[ 5 ] + 1;
	if ( lParam and $40 ) <> 0 then PortIrCnt[ 6 ] := PortIrCnt[ 6 ] + 1;
	if ( lParam and $80 ) <> 0 then PortIrCnt[ 7 ] := PortIrCnt[ 7 ] + 1;
end;
//===================================================================
// 
//===================================================================
procedure TMainForm.FormCreate(Sender: TObject);
var
	Ri:				APCI9131RESOURCE; // \[X
	dwDllVer: DWORD;						// DLL o[W
	dwDrvVer: DWORD;						// Driver o[W
	bSwVal:		BYTE;							// BSN l
  bTimer:   BYTE;             // ^C}荞ݎ
	i:				Integer;
begin
	wBsn		 := APCI9131_BSN_AUTO;
	TimerCnt := 0;
	for i := 0 to 7 do PortIrCnt[ i ] := 0;
	//-----------------------------------------------------------------
	// DLL gp錾
	//-----------------------------------------------------------------
	if Apci9131wDllOpen() = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;											// DLL [hs
	end;
	ResultMessage( 'DLL [h܂' );
	//-----------------------------------------------------------------
	// o[W擾
	//-----------------------------------------------------------------
	if Apci9131wGetVersion( dwDllVer, dwDrvVer ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	szBuf := Format( 'GetVersion'#10 +
									 'DLL Version'#09 + ': %0.8xH'#10 +
									 'Driver Version'#09 + ': %0.8xH',
									 [ dwDllVer, dwDrvVer ] );
	ResultMessage( szBuf );
	//-----------------------------------------------------------------
	// foCXgp錾
	//-----------------------------------------------------------------
	if Apci9131wCreate( wBsn, Handle, WM_APCI9131 ) = False then begin
		ErrorMessage( APCI9131_BSN_AUTO );
		Halt;
	end;
	ResultMessage( 'aPCI-9131 Create' );
	//-----------------------------------------------------------------
	// \[X BSN l擾
	//-----------------------------------------------------------------
	if Apci9131wGetResource( wBsn, @Ri ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	if Apci9131wGetSwitchValue( wBsn, bSwVal ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	szBuf := Format( 'APIC21 I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
									 'Device I/O Address'#09 + ': %0.4xH - %0.4xH'#10 +
									 'IRQ Number'#09 + ': %0.2d'#10 +
									 'BSN Value'#09 + ': %0.2xH',
									 [ Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
										 Ri.dwIoBase[ 2 ], Ri.dwIoBase[ 2 ] + Ri.dwIoLength[ 2 ] - 1,
										 Ri.dwIrq, bSwVal ] );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
  RegInit( nil );
	//-----------------------------------------------------------------
	// ̓|[g荞݃|eBݒ
	// SẴ|[g̓tHgJv OFFON ̕ω (オGbW) 
	// 荞ݔ
	//-----------------------------------------------------------------
	if Apci9131wSetIrPolarity( wBsn, $FF ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	ResultMessage( '̓|[g荞݃|eBݒ肵܂' );
	//-----------------------------------------------------------------
	// SĂ̓̓|[g荞݂Cl[u
	//-----------------------------------------------------------------
	if Apci9131wSetPortIr( wBsn, $FF ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	ResultMessage( '̓|[g̊荞݂Lɂ܂' );
	//-----------------------------------------------------------------
	// ^C}N (100ms)
	//-----------------------------------------------------------------
  bTimer := 100;
	if Apci9131wSetTimer( wBsn, bTimer ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
  szBuf := Format( '^C}N܂'#10 +
                   '荞ݔ : %dms',
                   [ bTimer ] );
	ResultMessage( szBuf );
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if TimerCnt < 20 then DataShow( nil );
	//-----------------------------------------------------------------
	// foCXgpJ
	//-----------------------------------------------------------------
	if Apci9131wClose( wBsn ) = True then
		ResultMessage( 'aPCI-9131 Close' );
	//-----------------------------------------------------------------
	// DLL gpJ
	//-----------------------------------------------------------------
	if Apci9131wDllClose() = True then
		ResultMessage( 'DLL A[h܂' );
end;
//===================================================================
// f[^\
//===================================================================
procedure TMainForm.DataShow( Sender: TObject );
begin
	//-----------------------------------------------------------------
	// ^C}~
	//-----------------------------------------------------------------
	if Apci9131wSetTimer( wBsn, 0 ) = True then
		ResultMessage( '^C}荞݂𖳌ɂ܂' );
	//-----------------------------------------------------------------
	// SĂ̓̓|[g荞݂fBZ[u
	//-----------------------------------------------------------------
	if Apci9131wSetPortIr( wBsn, $00 ) = True then
		ResultMessage( '̓|[g̊荞݂𖳌ɂ܂' );
  //-----------------------------------------------------------------
	// CNgf[^\
	//-----------------------------------------------------------------
	szBuf := Format( '^C}荞ݔ : %d'#10 +
									 '̓|[g1 荞ݔ : %d'#10 +
									 '̓|[g2 荞ݔ : %d'#10 +
									 '̓|[g3 荞ݔ : %d'#10 +
									 '̓|[g4 荞ݔ : %d'#10 +
									 '̓|[g5 荞ݔ : %d'#10 +
									 '̓|[g6 荞ݔ : %d'#10 +
									 '̓|[g7 荞ݔ : %d'#10 +
									 '̓|[g8 荞ݔ : %d'#10,
									 [ TimerCnt, PortIrCnt[ 0 ], PortIrCnt[ 1 ],
										 PortIrCnt[ 2 ], PortIrCnt[ 3 ], PortIrCnt[ 4 ],
										 PortIrCnt[ 5 ], PortIrCnt[ 6 ], PortIrCnt[ 7 ] ] );
	ResultMessage( szBuf );
end;
//===================================================================
// lݒ
//===================================================================
procedure TMainForm.RegInit( Sender: TObject );
begin
	//---------------------------------------------------------------
	// ̓|[g荞݃|eBWX^
	//---------------------------------------------------------------
	if Apci9131wSetIrPolarity( wBsn, $00 ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	//---------------------------------------------------------------
	// ̓|[g荞݃Cl[uWX^ (荞݋֎~)
	//---------------------------------------------------------------
	if Apci9131wSetPortIr( wBsn, $00 ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
	//---------------------------------------------------------------
	// ^C}荞 (gp)
	//---------------------------------------------------------------
	if Apci9131wSetTimer( wBsn, $00 ) = False then begin
		ErrorMessage( wBsn );
		Halt;
	end;
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage( strbuf: String );
begin
	Application.MessageBox( PChar( strbuf ), szTitle, MB_OK + MB_ICONINFORMATION );
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage( bsn: WORD );
var
	dwRes:	DWORD;
	szBuf: String;
begin
	dwRes := Apci9131wGetLastError( bsn );

	if dwRes = APCI9131_ERR_WRAPDLL then
    szBuf := 'DLL Load error'
  else
    szBuf := Format( 'aPCI-9131 error'#10#10'Error code : %xH', [ dwRes ] );

	Application.MessageBox( PChar( szBuf ), szTitle, MB_OK + MB_ICONSTOP );
end;

end.
