//===================================================================
// Apci9131w.pas -- wrapper for Delphi
//-------------------------------------------------------------------
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
unit Apci9131w;

interface

uses
	Windows, SysUtils;

const
	APCI9131_SUCCESS							= 0;		// ُȂ (I)
	APCI9131_ERR_SYSTEM						= 1;		// VXeG[
	APCI9131_ERR_NO_DEVICE				= 2;		// gp\ȃfoCX܂
	APCI9131_ERR_IN_USE						= 3;		// w̃foCX͎gpł
	APCI9131_ERR_INVALID_BSN			= 4;		//  BSN lł
	APCI9131_ERR_RESOURCE					= 5;		// \[XG[
	APCI9131_ERR_INVALID_ARGUMENT = 6;		// sȈv܂

	APCI9131_ERR_REGION						= 10;		// sȗ̈w
	APCI9131_ERR_OFFSET						= 11;		// sȃItZbgw

	APCI9131_ERR_WRAPDLL					= $FFFF;

	APCI9131_BSN_AUTO							= $FFFF;
	APCI9131_MAX_SLOTS						= 16;
	APCI9131_DLL_NAME							= 'Apci9131.dll';

	APCI9131_MAX_IO								= 6;

	// o̓|[gWX^
	APCI9131_PORT1								= $00;
	APCI9131_PORT2								= $01;
	APCI9131_PORT3								= $02;
	APCI9131_PORT4								= $03;
	APCI9131_PORT5								= $04;
	APCI9131_PORT6								= $05;
	APCI9131_PORT7								= $06;
	APCI9131_PORT8								= $07;

	// tB^^CWX^
	APCI9131_F_PORT1							= $08;
	APCI9131_F_PORT2							= $09;
	APCI9131_F_PORT3							= $0A;
	APCI9131_F_PORT4							= $0B;
	APCI9131_F_PORT5							= $0C;
	APCI9131_F_PORT6							= $0D;
	APCI9131_F_PORT7							= $0E;
	APCI9131_F_PORT8							= $0F;
	APCI9131_F_STB_ACK						= $10;

	// 荞ݒʒm
	APCI9131_MSG_TIMER						= 0;
	APCI9131_MSG_PORT							= 1;
	APCI9131_MSG_IACK							= 2;
	APCI9131_MSG_ISTB							= 3;

type
	APCI9131RESOURCE = record
		dwNumIoRegion:														 DWORD; // I/O ̈搔
		dwIoBase:		Array[ 1..APCI9131_MAX_IO ] of DWORD; // I/O |[gx[X
		dwIoLength: Array[ 1..APCI9131_MAX_IO ] of DWORD; // I/O |[g
		dwIrq:																		 DWORD; // 荞ݔԍ
	end;
	PAPCI9131R = ^APCI9131RESOURCE;

//function
	function Apci9131wDllOpen: Boolean;
	function Apci9131wDllClose: Boolean;
	function Apci9131wGetVersion( var pdwDllVersion: DWORD; var pdwDrvVersion: DWORD ): Boolean;
	function Apci9131wCreate( var pwBsn: WORD; hWnd: HWND; uWMBase: UINT ): Boolean;
	function Apci9131wClose( wBsn: WORD ): Boolean;
	function Apci9131wGetResource( wBsn: WORD; pRes: PAPCI9131R ): Boolean;
	function Apci9131wGetSwitchValue( wBsn: WORD; var pbValue: BYTE ): Boolean;
	function Apci9131wInitialize( wBsn: WORD ): Boolean;
	function Apci9131wSetTimer( wBsn: WORD; dwCount: DWORD ): Boolean;
	function Apci9131wInportb( wBsn: WORD; dwPort: DWORD; var pData: BYTE ): Boolean;
	function Apci9131wOutportb( wBsn: WORD; dwPort: DWORD; Data: BYTE ): Boolean;
	function Apci9131wSetFilter( wBsn: WORD; dwPort: DWORD; Cnt: BYTE ): Boolean;
	function Apci9131wGetFilter( wBsn: WORD; dwPort: DWORD; var pCnt: BYTE ): Boolean;
	function Apci9131wSetIrPolarity( wBsn: WORD; Pol: BYTE ): Boolean;
	function Apci9131wGetIrPolarity( wBsn: WORD; var pPol: BYTE ): Boolean;
	function Apci9131wSetPortIr( wBsn: WORD; Ir: BYTE ): Boolean;
	function Apci9131wGetPortIr( wBsn: WORD; var pIr: BYTE ): Boolean;
	function Apci9131wSetStbAckIr( wBsn: WORD; Ir: BYTE ): Boolean;
	function Apci9131wGetStbAckIr( wBsn: WORD; var pIr: BYTE ): Boolean;
	function Apci9131wSetStbEnableRegs( wBsn: WORD; Sen: BYTE ): Boolean;
	function Apci9131wGetStbEnableRegs( wBsn: WORD; var pSen: BYTE ): Boolean;
	function Apci9131wSetAckMode( wBsn: WORD; Ackm: BYTE ): Boolean;
	function Apci9131wGetAckMode( wBsn: WORD; var pAckm: BYTE ): Boolean;
	function Apci9131wSetLedRegs( wBsn: WORD; Led: BYTE ): Boolean;
	function Apci9131wGetLedRegs( wBsn: WORD; var pLed: BYTE ): Boolean;
	function Apci9131wStbOut( wBsn: WORD; Stb: BYTE ): Boolean;
	function Apci9131wAckOut( wBsn: WORD; Ack: BYTE ): Boolean;
	function Apci9131wGetLastError( wBsn: WORD ): DWORD;

implementation

{$J+} // ^t萔̕ύX\RpCw

const
	hDLL: THandle = 0;

type
	TApci9131GetVersion				= function ( var pdwDllVersion: DWORD; var pdwDrvVersion: DWORD ): Boolean; stdcall;
	TApci9131Create						= function ( var pwBsn: WORD; hWnd: HWND; uWMBase: UINT ): Boolean; stdcall;
	TApci9131Close						= function ( wBsn: WORD ): Boolean; stdcall;
	TApci9131GetResource			= function ( wBsn: WORD; pRes: PAPCI9131R ): Boolean; stdcall;
	TApci9131GetSwitchValue		= function ( wBsn: WORD; var pbValue: BYTE ): Boolean; stdcall;
	TApci9131Initialize				= function ( wBsn: WORD ): Boolean; stdcall;
	TApci9131SetTimer					= function ( wBsn: WORD; dwCount: DWORD ): Boolean; stdcall;
	TApci9131Inportb					= function ( wBsn: WORD; dwPort: DWORD; var pData: BYTE ): Boolean; stdcall;
	TApci9131Outportb					= function ( wBsn: WORD; dwPort: DWORD; Data: BYTE ): Boolean; stdcall;
	TApci9131SetFilter				= function ( wBsn: WORD; dwPort: DWORD; Cnt: BYTE ): Boolean; stdcall;
	TApci9131GetFilter				= function ( wBsn: WORD; dwPort: DWORD; var pCnt: BYTE ): Boolean; stdcall;
	TApci9131SetIrPolarity		= function ( wBsn: WORD; Pol: BYTE ): Boolean; stdcall;
	TApci9131GetIrPolarity		= function ( wBsn: WORD; var pPol: BYTE ): Boolean; stdcall;
	TApci9131SetPortIr				= function ( wBsn: WORD; Ir: BYTE ): Boolean; stdcall;
	TApci9131GetPortIr				= function ( wBsn: WORD; var pIr: BYTE ): Boolean; stdcall;
	TApci9131SetStbAckIr			= function ( wBsn: WORD; Ir: BYTE ): Boolean; stdcall;
	TApci9131GetStbAckIr			= function ( wBsn: WORD; var pIr: BYTE ): Boolean; stdcall;
	TApci9131SetStbEnableRegs = function ( wBsn: WORD; Sen: BYTE ): Boolean; stdcall;
	TApci9131GetStbEnableRegs = function ( wBsn: WORD; var pSen: BYTE ): Boolean; stdcall;
	TApci9131SetAckMode				= function ( wBsn: WORD; Ackm: BYTE ): Boolean; stdcall;
	TApci9131GetAckMode				= function ( wBsn: WORD; var pAckm: BYTE ): Boolean; stdcall;
	TApci9131SetLedRegs				= function ( wBsn: WORD; Led: BYTE ): Boolean; stdcall;
	TApci9131GetLedRegs				= function ( wBsn: WORD; var pLed: BYTE ): Boolean; stdcall;
	TApci9131StbOut						= function ( wBsn: WORD; Stb: BYTE ): Boolean; stdcall;
	TApci9131AckOut						= function ( wBsn: WORD; Ack: BYTE ): Boolean; stdcall;
	TApci9131GetLastError			= function ( wBsn: WORD ): DWORD; stdcall;

// DLL GNX|[g֐AhX̊i[ϐ
var
	pApci9131GetVersion:			 TApci9131GetVersion;
	pApci9131Create:					 TApci9131Create;
	pApci9131Close:						 TApci9131Close;
	pApci9131GetResource:			 TApci9131GetResource;
	pApci9131GetSwitchValue:	 TApci9131GetSwitchValue;
	pApci9131Initialize:			 TApci9131Initialize;
	pApci9131SetTimer:				 TApci9131SetTimer;
	pApci9131Inportb:					 TApci9131Inportb;
	pApci9131Outportb:				 TApci9131Outportb;
	pApci9131SetFilter:				 TApci9131SetFilter;
	pApci9131GetFilter:				 TApci9131GetFilter;
	pApci9131SetIrPolarity:		 TApci9131SetIrPolarity;
	pApci9131GetIrPolarity:		 TApci9131GetIrPolarity;
	pApci9131SetPortIr:				 TApci9131SetPortIr;
	pApci9131GetPortIr:				 TApci9131GetPortIr;
	pApci9131SetStbAckIr:			 TApci9131SetStbAckIr;
	pApci9131GetStbAckIr:			 TApci9131GetStbAckIr;
	pApci9131SetStbEnableRegs: TApci9131SetStbEnableRegs;
	pApci9131GetStbEnableRegs: TApci9131GetStbEnableRegs;
	pApci9131SetAckMode:			 TApci9131SetAckMode;
	pApci9131GetAckMode:			 TApci9131GetAckMode;
	pApci9131SetLedRegs:			 TApci9131SetLedRegs;
	pApci9131GetLedRegs:			 TApci9131GetLedRegs;
	pApci9131StbOut:					 TApci9131StbOut;
	pApci9131AckOut:					 TApci9131AckOut;
	pApci9131GetLastError:		 TApci9131GetLastError;

	function _Apci9131wGetDllExportFunc: Boolean; forward;

{$J-}

//===================================================================
// 	 		DLL [h (񃍁[h̓G[Ƃ)
// 	 		Ȃ
// ߂l				True
//					s		False
//===================================================================
function Apci9131wDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary( APCI9131_DLL_NAME );
		if hDLL <> 0 then begin
			if _Apci9131wGetDllExportFunc = True then
				Result := True
			else
				Apci9131wDllClose;		// DLL ֐擾Ɏŝ DLL N[Y
		end;
	end;
end;
//===================================================================
// 	 		DLL A[h (A[h̓G[Ƃ)
// 	 		Ȃ
// ߂l				True
//					s		False
//===================================================================
function Apci9131wDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		if True = FreeLibrary( hDLL ) then begin
			hDLL	 := 0;
			Result := True;
		end;
	end;
end;
//===================================================================
// 	 		DLLADriver ̃o[W擾
// 	 		pdwDllVersion DLL o[Wԍi[̈
//					pdwDrvVersion Driver o[Wԍi[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetVersion( var pdwDllVersion: DWORD; var pdwDrvVersion: DWORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetVersion( pdwDllVersion, pdwDrvVersion );
end;
//===================================================================
// 	 		foCXgp錾
// 	 		pwBsn		gpfoCX BSN li[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wCreate( var pwBsn: WORD; hWnd: HWND; uWMBase: UINT ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131Create( pwBsn, hWnd, uWMBase );
end;
//===================================================================
// 	 		foCXJ
// 	 		wBsn		foCX BSN l
// ߂l				True
//					s		False
//===================================================================
function Apci9131wClose( wBsn: WORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131Close( wBsn );
end;
//===================================================================
// 	 		\[X擾
// 	 		wBsn		foCX BSN l
//					pRes		\[Xi[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetResource( wBsn: WORD; pRes: PAPCI9131R ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetResource( wBsn, pRes );
end;
//===================================================================
// 	 		BSN l擾
// 	 		wBsn		foCX BSN l
//					pbValue	BSN li[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetSwitchValue( wBsn: WORD; var pbValue: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetSwitchValue( wBsn, pbValue );
end;
//===================================================================
// 	 		foCX
// 	 		wBsn		foCX BSN l
// ߂l				True
//					s		False
//===================================================================
function Apci9131wInitialize( wBsn: WORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131Initialize( wBsn );
end;
//===================================================================
// 	 		^C}ݒ
// 	 		wBsn		foCX BSN l
//					dwCount	^C}荞ݔ
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetTimer( wBsn: WORD; dwCount: DWORD ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetTimer( wBsn, dwCount );
end;
//===================================================================
// 	 		|[g
// 	 		wBsn		foCX BSN l
//					dwPort	̓|[gԍ
//					pData		͒li[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wInportb( wBsn: WORD; dwPort: DWORD; var pData: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131Inportb( wBsn, dwPort, pData );
end;
//===================================================================
// 	 		|[go
// 	 		wBsn		foCX BSN l
//					dwPort	o̓|[gԍ
//					Data		o͒l
// ߂l				True
//					s		False
//===================================================================
function Apci9131wOutportb( wBsn: WORD; dwPort: DWORD; Data: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131Outportb( wBsn, dwPort, Data );
end;
//===================================================================
// 	 		̓|[g/STB_IN/ACK_IN tB^^Cݒ
// 	 		wBsn		foCX BSN l
//					dwPort	ݒΏۂ̃|[gԍ
//					Cnt			JE^wl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetFilter( wBsn: WORD; dwPort: DWORD; Cnt: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetFilter( wBsn, dwPort, Cnt );
end;
//===================================================================
// 	 		̓|[g/STB_IN/ACK_IN tB^^Cݒl擾
// 	 		wBsn		foCX BSN l
//					dwPort	ݒΏۂ̃|[gԍ
//					pCnt		JE^wli[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetFilter( wBsn: WORD; dwPort: DWORD; var pCnt: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetFilter( wBsn, dwPort, pCnt );
end;
//===================================================================
// 	 		荞݃|eBݒ
// 	 		wBsn		foCX BSN l
//					Pol			͊荞݃|eBWX^ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetIrPolarity( wBsn: WORD; Pol: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetIrPolarity( wBsn, Pol );
end;
//===================================================================
// 	 		荞݃|eBݒl擾
// 	 		wBsn		foCX BSN l
//					pPol		͊荞݃|eBWX^ݒli[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetIrPolarity( wBsn: WORD; var pPol: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetIrPolarity( wBsn, pPol );
end;
//===================================================================
// 	 		̓|[g荞ݐݒ
// 	 		wBsn		foCX BSN l
//					Ir			荞݃Cl[uWX^ (̓|[g) ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetPortIr( wBsn: WORD; Ir: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetPortIr( wBsn, Ir );
end;
//===================================================================
// 	 		̓|[g荞ݐݒl擾
// 	 		wBsn		foCX BSN l
//					pIr			荞݃Cl[uWX^ (̓|[g) ݒl
//									i[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetPortIr( wBsn: WORD; var pIr: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetPortIr( wBsn, pIr );
end;
//===================================================================
// 	 		STB/ACK 荞ݐݒ
// 	 		wBsn		foCX BSN l
//					Ir			荞݃Cl[uWX^ (STB/ACK) ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetStbAckIr( wBsn: WORD; Ir: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetStbAckIr( wBsn, Ir );
end;
//===================================================================
// 	 		STB/ACK 荞ݐݒl擾
// 	 		wBsn		foCX BSN l
//					pIr			荞݃Cl[uWX^ (STB/ACK) ݒl
//									i[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetStbAckIr( wBsn: WORD; var pIr: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetStbAckIr( wBsn, pIr );
end;
//===================================================================
// 	 		STB_IN Cl[uWX^ݒ
// 	 		wBsn		foCX BSN l
//					Sen			STB_IN Cl[uWX^ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetStbEnableRegs( wBsn: WORD; Sen: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetStbEnableRegs( wBsn, Sen );
end;
//===================================================================
// 	 		STB_IN Cl[uWX^ݒl擾
// 	 		wBsn		foCX BSN l
//					pSen		STB_IN Cl[uWX^ݒli[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetStbEnableRegs( wBsn: WORD; var pSen: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetStbEnableRegs( wBsn, pSen );
end;
//===================================================================
// 	 		ACK/RDY [hWX^ݒ
// 	 		wBsn		foCX BSN l
//					Ackm		ACK/BUSY [hWX^ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetAckMode( wBsn: WORD; Ackm: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetAckMode( wBsn, Ackm );
end;
//===================================================================
// 	 		ACK/RDY [hWX^ݒl擾
// 	 		wBsn		foCX BSN l
//					pAckm		ACK/BUSY [hWX^ݒli[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetAckMode( wBsn: WORD; var pAckm: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetAckMode( wBsn, pAckm );
end;
//===================================================================
// 	 		LED 䃌WX^ݒ
// 	 		wBsn		foCX BSN l
//					Led			LED 䃌WX^ݒl
// ߂l				True
//					s		False
//===================================================================
function Apci9131wSetLedRegs( wBsn: WORD; Led: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131SetLedRegs( wBsn, Led );
end;
//===================================================================
// 	 		LED 䃌WX^ݒl擾
// 	 		wBsn		foCX BSN l
//					pLed		LED 䃌WX^ݒli[̈
// ߂l				True
//					s		False
//===================================================================
function Apci9131wGetLedRegs( wBsn: WORD; var pLed: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131GetLedRegs( wBsn, pLed );
end;
//===================================================================
// 	 		STB o
// 	 		wBsn		foCX BSN l
//					Stb			STB o͒l
// ߂l				True
//					s		False
//===================================================================
function Apci9131wStbOut( wBsn: WORD; Stb: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131StbOut( wBsn, Stb );
end;
//===================================================================
// 	 		ACK o
// 	 		wBsn		foCX BSN l
//					Ack			ACK o͒l
// ߂l				True
//					s		False
//===================================================================
function Apci9131wAckOut( wBsn: WORD; Ack: BYTE ): Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pApci9131AckOut( wBsn, Ack );
end;
//===================================================================
// 	 		G[擾
// 	 		wBsn		foCX BSN l
// ߂l		G[
//===================================================================
function Apci9131wGetLastError( wBsn: WORD ): DWORD;
begin
	if hDLL = 0 then
		Result := APCI9131_ERR_WRAPDLL
	else
		Result := pApci9131GetLastError( wBsn );
end;

//-------------------------------------------------------------------
// 	 		DLL GNX|[g֐AhX̎擾
// 	 		Ȃ
// ߂l				True
//					s		False
//-------------------------------------------------------------------
function _Apci9131wGetDllExportFunc: Boolean;
begin
	Result := False;

	pApci9131GetVersion				:= GetProcAddress( hDLL, 'Apci9131GetVersion' );
	pApci9131Create						:= GetProcAddress( hDLL, 'Apci9131Create' );
	pApci9131Close						:= GetProcAddress( hDLL, 'Apci9131Close' );
	pApci9131GetResource			:= GetProcAddress( hDLL, 'Apci9131GetResource' );
	pApci9131GetSwitchValue		:= GetProcAddress( hDLL, 'Apci9131GetSwitchValue' );
	pApci9131Initialize				:= GetProcAddress( hDLL, 'Apci9131Initialize' );
	pApci9131SetTimer					:= GetProcAddress( hDLL, 'Apci9131SetTimer' );
	pApci9131Inportb					:= GetProcAddress( hDLL, 'Apci9131Inportb' );
	pApci9131Outportb					:= GetProcAddress( hDLL, 'Apci9131Outportb' );
	pApci9131SetFilter				:= GetProcAddress( hDLL, 'Apci9131SetFilter' );
	pApci9131GetFilter				:= GetProcAddress( hDLL, 'Apci9131GetFilter' );
	pApci9131SetIrPolarity		:= GetProcAddress( hDLL, 'Apci9131SetIrPolarity' );
	pApci9131GetIrPolarity		:= GetProcAddress( hDLL, 'Apci9131GetIrPolarity' );
	pApci9131SetPortIr				:= GetProcAddress( hDLL, 'Apci9131SetPortIr' );
	pApci9131GetPortIr				:= GetProcAddress( hDLL, 'Apci9131GetPortIr' );
	pApci9131SetStbAckIr			:= GetProcAddress( hDLL, 'Apci9131SetStbAckIr' );
	pApci9131GetStbAckIr			:= GetProcAddress( hDLL, 'Apci9131GetStbAckIr' );
	pApci9131SetStbEnableRegs := GetProcAddress( hDLL, 'Apci9131SetStbEnableRegs' );
	pApci9131GetStbEnableRegs := GetProcAddress( hDLL, 'Apci9131GetStbEnableRegs' );
	pApci9131SetAckMode				:= GetProcAddress( hDLL, 'Apci9131SetAckMode' );
	pApci9131GetAckMode				:= GetProcAddress( hDLL, 'Apci9131GetAckMode' );
	pApci9131SetLedRegs				:= GetProcAddress( hDLL, 'Apci9131SetLedRegs' );
	pApci9131GetLedRegs				:= GetProcAddress( hDLL, 'Apci9131GetLedRegs' );
	pApci9131StbOut						:= GetProcAddress( hDLL, 'Apci9131StbOut' );
	pApci9131AckOut						:= GetProcAddress( hDLL, 'Apci9131AckOut' );
	pApci9131GetLastError			:= GetProcAddress( hDLL, 'Apci9131GetLastError' );

	if @pApci9131GetVersion				= nil then Exit;
	if @pApci9131Create						= nil then Exit;
	if @pApci9131Close						= nil then Exit;
	if @pApci9131GetResource			= nil then Exit;
	if @pApci9131GetSwitchValue		= nil then Exit;
	if @pApci9131Initialize				= nil then Exit;
	if @pApci9131SetTimer					= nil then Exit;
	if @pApci9131Inportb					= nil then Exit;
	if @pApci9131Outportb					= nil then Exit;
	if @pApci9131SetFilter				= nil then Exit;
	if @pApci9131GetFilter				= nil then Exit;
	if @pApci9131SetIrPolarity		= nil then Exit;
	if @pApci9131GetIrPolarity		= nil then Exit;
	if @pApci9131SetPortIr				= nil then Exit;
	if @pApci9131GetPortIr				= nil then Exit;
	if @pApci9131SetStbAckIr			= nil then Exit;
	if @pApci9131GetStbAckIr			= nil then Exit;
	if @pApci9131SetStbEnableRegs = nil then Exit;
	if @pApci9131GetStbEnableRegs = nil then Exit;
	if @pApci9131SetAckMode				= nil then Exit;
	if @pApci9131GetAckMode				= nil then Exit;
	if @pApci9131SetLedRegs				= nil then Exit;
	if @pApci9131GetLedRegs				= nil then Exit;
	if @pApci9131StbOut						= nil then Exit;
	if @pApci9131AckOut						= nil then Exit;
	if @pApci9131GetLastError			= nil then Exit;

	// ׂĂ DLL GNX|[g֐AhX擾 OK
	Result := True;
end;

end.
