//===================================================================
// Apci9131s.c -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// Po (tB^O) s܂
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#define STRICT

#include <windows.h>
#include <tchar.h>

#include "Apci9131w.h"

const TCHAR szTitle[] = _T( "Sample" );

static void ResultMessage( LPCTSTR lpszbuf );
static void ErrorMessage( WORD bsn );

BOOL	RegInit( void );

WORD wBsn;

//===================================================================
// Main
//===================================================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow )
{
	APCI9131RESOURCE Ri;			// \[X
	DWORD			 dwDllVer;		// DLL o[W
	DWORD			 dwDrvVer;		// Driver o[W
	BYTE			 bSwVal;		// BSN l
	BYTE			 bCnt;			// tB^^CWX^ݒl
	BYTE			 bData;			// o͒l
	TCHAR			 szBuf[ 256 ];

	wBsn = APCI9131_BSN_AUTO;
	//---------------------------------------------------------------
	// DLL gp錾
	//---------------------------------------------------------------
	if ( Apci9131wDllOpen() == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;					// DLL [hs
	}
	ResultMessage( "DLL [h܂" );
	//---------------------------------------------------------------
	// o[W擾
	//---------------------------------------------------------------
	if ( Apci9131wGetVersion( &dwDllVer, &dwDrvVer ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	wsprintf( szBuf, _T( "GetVersion\n" )
					 _T( "DLL Version\t: %08XH\n" )
					 _T( "Driver Version\t: %08XH\n" ),
					 dwDllVer, dwDrvVer );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCXgp錾
	//---------------------------------------------------------------
	if ( Apci9131wCreate( &wBsn, NULL, 0 ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	ResultMessage( "aPCI-9131 Create" );
	//---------------------------------------------------------------
	// \[X BSN l擾
	//---------------------------------------------------------------
	if ( Apci9131wGetResource( wBsn, &Ri ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	if ( Apci9131wGetSwitchValue( wBsn, &bSwVal ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "APIC21 I/O Address\t: %04XH - %04XH\n" )
					 _T( "Device I/O Address\t: %04XH - %04XH\n" )
					 _T( "IRQ Number\t: %02d\n" )
					 _T( "BSN Value\t: %02XH" ),
					 Ri.dwIoBase[ 0 ], Ri.dwIoBase[ 0 ] + Ri.dwIoLength[ 0 ] - 1,
					 Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
					 Ri.dwIrq, bSwVal );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
	RegInit();
	//---------------------------------------------------------------
	// |[g1 ̃`^OtB^ݒ
	//---------------------------------------------------------------
	bCnt = 0;
	if ( Apci9131wSetFilter( wBsn, APCI9131_F_PORT1, bCnt ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "|[g1 ̃`^OtB^ݒ肵܂\n" )
					 _T( "tB^ : %ds" ),
					 ( bCnt * 10 ) );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// |[g1 Ƀf[^
	//---------------------------------------------------------------
	bData = 0xAA;
	if ( Apci9131wOutportb( wBsn, APCI9131_PORT1, bData ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "|[g1 Ƀf[^݂܂\n" )
					 _T( "Write Data : %02XH" ),
					 bData );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// |[g1 f[^ǂݍ
	//---------------------------------------------------------------
	bData = 0x00;
	if ( Apci9131wInportb( wBsn, APCI9131_PORT1, &bData ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "|[g1 f[^ǂݍ݂܂\n" )
					 _T( "Read Data : %02XH" ),
					 bData );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCXgpJ
	//---------------------------------------------------------------
	if ( Apci9131wClose( wBsn ) == TRUE )
		ResultMessage( "aPCI-9131 Close" );
	//---------------------------------------------------------------
	// DLL gpJ
	//---------------------------------------------------------------
	if ( Apci9131wDllClose() == TRUE )
		ResultMessage( "DLL A[h܂" );

	return TRUE;
}
//===================================================================
// lݒ
//===================================================================
BOOL RegInit( void )
{
	//---------------------------------------------------------------
	// o̓|[gWX^1
	//---------------------------------------------------------------
	if ( Apci9131wOutportb( wBsn, APCI9131_PORT1, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// tB^^CWX^1 (tB^ OFF)
	//---------------------------------------------------------------
	if ( Apci9131wSetFilter( wBsn, APCI9131_F_PORT1, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}

	return TRUE;
}
//===================================================================
// ʂ\
//===================================================================
static void ResultMessage( LPCTSTR lpszbuf )
{
	MessageBox( NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION );
}
//===================================================================
// G[bZ[W\
//===================================================================
static void ErrorMessage( WORD bsn )
{
	DWORD	dwRes = Apci9131wGetLastError( bsn );
	TCHAR	szbuf[ 50 ];

	switch ( dwRes ) {
		case APCI9131_ERR_WRAPDLL:
			wsprintf( szbuf, _T( "DLL Load error" ) );
			break;
		default:
			wsprintf( szbuf, _T( "aPCI-9131 error\n\n" )
							 _T( "Error code : %XH" ),
							 dwRes );
			break;
	}

	MessageBox( NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP );

	// I
	Apci9131wClose( bsn );
	Apci9131wDllClose();
}
