//===================================================================
// Apci9131s.c -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// nhVF[N[hŃ|[g1 ͂Əo͂̃[vobNs܂
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#define STRICT

#include <windows.h>
#include <tchar.h>

#include "Apci9131w.h"

#define WM_APCI9131			WM_USER + 100
#define WM_APCI9131_IACK	WM_APCI9131 + APCI9131_MSG_IACK
#define WM_APCI9131_ISTB	WM_APCI9131 + APCI9131_MSG_ISTB

const TCHAR szTitle[] = _T( "Sample" );

static void ResultMessage( LPCTSTR lpszbuf );
static void ErrorMessage( WORD bsn );

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

BOOL	OnCreate( HWND hWnd );
BOOL	OnDestroy( void );
BOOL	OnAck( WPARAM );
BOOL	OnStb( WPARAM );
BOOL	DataShow( void );
BOOL	RegInit( void );

WORD	wBsn;
TCHAR	szBuf[ 2048 ];
BYTE	IncData;
char	szClassName[] = "TvvO";

//===================================================================
// Main
//===================================================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow )
{
	MSG			msg;
	WNDCLASS	wc;
	HWND		hWnd;

	//---------------------------------------------------------------
	// EChENXo^
	//---------------------------------------------------------------
	if ( !hPrevInstance ) {
		wc.style		 = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc	 = WndProc;
		wc.cbClsExtra	 = 0;
		wc.cbWndExtra	 = 0;
		wc.hInstance	 = hInstance;
		wc.hIcon		 = NULL;
		wc.hCursor		 = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = GetStockObject( WHITE_BRUSH );
		wc.lpszMenuName	 = NULL;
		wc.lpszClassName = szClassName;
		if ( !RegisterClass( &wc ) )
			return FALSE;
	}
	//---------------------------------------------------------------
	// EChE쐬
	//---------------------------------------------------------------
	hWnd = CreateWindow( szClassName,
						 szTitle,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 NULL,
						 NULL,
						 hInstance,
						 NULL );

	if ( hWnd == NULL )
		return FALSE;
	//---------------------------------------------------------------
	// EChE\
	//---------------------------------------------------------------
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );
	//---------------------------------------------------------------
	// bZ[W[v
	//---------------------------------------------------------------
	while ( GetMessage( &msg, NULL, 0, 0 ) ) {
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	return ( msg.wParam );
}
//===================================================================
// EChEbZ[W
//===================================================================
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch ( msg ) {

		case WM_SHOWWINDOW:
			OnCreate( hWnd );
			break;

		case WM_APCI9131_IACK:
			OnAck( wParam );
			break;

		case WM_APCI9131_ISTB:
			OnStb( wParam );
			break;

		case WM_DESTROY:
			OnDestroy();
			PostQuitMessage( 0 );
			break;

		default:
			return( DefWindowProc( hWnd, msg, wParam, lParam ) );
	}

	return 0;
}
//===================================================================
// 
//===================================================================
BOOL OnCreate( HWND hWnd )
{
	APCI9131RESOURCE Ri;			// \[X
	DWORD			 dwDllVer;		// DLL o[W
	DWORD			 dwDrvVer;		// Driver o[W
	BYTE			 bSwVal;		// BSN l

	wBsn    = APCI9131_BSN_AUTO;
	IncData = 0;
	//---------------------------------------------------------------
	// DLL gp錾
	//---------------------------------------------------------------
	if ( Apci9131wDllOpen() == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;					// DLL [hs
	}
	ResultMessage( "DLL [h܂" );
	//---------------------------------------------------------------
	// o[W擾
	//---------------------------------------------------------------
	if ( Apci9131wGetVersion( &dwDllVer, &dwDrvVer ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	wsprintf( szBuf, _T( "GetVersion\n" )
					 _T( "DLL Version\t: %08XH\n" )
					 _T( "Driver Version\t: %08XH\n" ),
					 dwDllVer, dwDrvVer );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCXgp錾
	//---------------------------------------------------------------
	if ( Apci9131wCreate( &wBsn, hWnd, WM_APCI9131 ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	ResultMessage( "aPCI-9131 Create" );
	//---------------------------------------------------------------
	// \[X BSN l擾
	//---------------------------------------------------------------
	if ( Apci9131wGetResource( wBsn, &Ri ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	if ( Apci9131wGetSwitchValue( wBsn, &bSwVal ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "APIC21 I/O Address\t: %04XH - %04XH\n" )
					 _T( "Device I/O Address\t: %04XH - %04XH\n" )
					 _T( "IRQ Number\t: %02d\n" )
					 _T( "BSN Value\t: %02XH" ),
					 Ri.dwIoBase[ 0 ], Ri.dwIoBase[ 0 ] + Ri.dwIoLength[ 0 ] - 1,
					 Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
					 Ri.dwIrq, bSwVal );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
	RegInit();
	//---------------------------------------------------------------
	// ̓|[g1 ݂̂nhVF[N[hɐݒ
	//---------------------------------------------------------------
	if ( Apci9131wSetStbEnableRegs( wBsn, 0x01 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "̓|[g1 nhVF[N[hɐݒ肵܂" );
	//---------------------------------------------------------------
	// STB/ACK ̊荞݃Cl[u
	//---------------------------------------------------------------
	if ( Apci9131wSetStbAckIr( wBsn, 0x11 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "STB/ACK ̊荞݂Lɂ܂" );
	//---------------------------------------------------------------
	// |[g1 Ƀf[^Zbg
	//---------------------------------------------------------------
	if ( Apci9131wOutportb( wBsn, APCI9131_PORT1, IncData ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "|[g1 Ƀf[^Zbg܂" );
	//---------------------------------------------------------------
	// STB o
	//---------------------------------------------------------------
	if ( Apci9131wStbOut( wBsn, 0x01 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "STB o͂܂" );

	return TRUE;
}
//===================================================================
// I
//===================================================================
BOOL OnDestroy( void )
{
	if ( IncData < 10 ) DataShow();
	//---------------------------------------------------------------
	// foCXgpJ
	//---------------------------------------------------------------
	if ( Apci9131wClose( wBsn ) == TRUE )
		ResultMessage( "aPCI-9131 Close" );
	//---------------------------------------------------------------
	// DLL gpJ
	//---------------------------------------------------------------
	if ( Apci9131wDllClose() == TRUE )
		ResultMessage( "DLL A[h܂" );

	return TRUE;
}
//===================================================================
// f[^\
//===================================================================
BOOL DataShow( void )
{
	//---------------------------------------------------------------
	// STB/ACK 荞݃fBZ[u
	//---------------------------------------------------------------
	if ( Apci9131wSetStbAckIr( wBsn, 0x00 ) == TRUE )
		ResultMessage( "STB/ACK ̊荞݂𖳌ɂ܂" );
	//---------------------------------------------------------------
	// ̓|[g1 ̃nhVF[N[h
	//---------------------------------------------------------------
	if ( Apci9131wSetStbEnableRegs( wBsn, 0x00 ) == TRUE )
		ResultMessage( "̓|[g1 ̃nhVF[N[h܂" );
	//---------------------------------------------------------------
	// CNgf[^\
	//---------------------------------------------------------------
	wsprintf( szBuf, _T( "CNgf[^ = %d\n" ), IncData );
	ResultMessage( szBuf );

	return TRUE;
}
//===================================================================
// lݒ
//===================================================================
BOOL RegInit( void )
{
	//---------------------------------------------------------------
	// o̓|[gWX^1
	//---------------------------------------------------------------
	if ( Apci9131wOutportb( wBsn, APCI9131_PORT1, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// STB_IN Cl[uWX^ (P̓[h)
	//---------------------------------------------------------------
	if ( Apci9131wSetStbEnableRegs( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// STB/ACK 荞݃Cl[uWX^ (荞݋֎~)
	//---------------------------------------------------------------
	if ( Apci9131wSetStbAckIr( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// STB o
	//---------------------------------------------------------------
	if ( Apci9131wStbOut( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}

	return TRUE;
}
//===================================================================
// ACK 荞ݏ
//===================================================================
BOOL OnAck( WPARAM wParam )
{
	//---------------------------------------------------------------
	// CNgf[^ 10 ɂȂI
	//---------------------------------------------------------------
	if ( IncData < 10 ) {
		IncData = IncData + 1;
		//---------------------------------------------------------------
		// |[g1 Ƀf[^Zbg
		//---------------------------------------------------------------
		if ( Apci9131wOutportb( (WORD)wParam, APCI9131_PORT1, IncData ) == FALSE ) {
			ErrorMessage( (WORD)wParam );
			return FALSE;
		}
		//---------------------------------------------------------------
		// Sleep (100ms)
		//---------------------------------------------------------------
		Sleep( 100 );
		//---------------------------------------------------------------
		// STB o
		//---------------------------------------------------------------
		if ( Apci9131wStbOut( (WORD)wParam, 0x01 ) == FALSE ) {
			ErrorMessage( (WORD)wParam );
			return FALSE;
		}
	}
	else
		DataShow();

	return TRUE;
}
//===================================================================
// STB 荞ݏ
//===================================================================
BOOL OnStb( WPARAM wParam )
{
	//---------------------------------------------------------------
	// |[g1 ̃f[^ǂݍ
	//---------------------------------------------------------------
	if ( Apci9131wInportb( (WORD)wParam, APCI9131_PORT1, &IncData ) == FALSE ) {
		ErrorMessage( (WORD)wParam );
		return FALSE;
	}
	//---------------------------------------------------------------
	// Sleep (100ms)
	//---------------------------------------------------------------
	Sleep( 100 );
	//---------------------------------------------------------------
	// ACK o
	//---------------------------------------------------------------
	if ( Apci9131wAckOut( (WORD)wParam, 0x01 ) == FALSE ) {
		ErrorMessage( (WORD)wParam );
		return FALSE;
	}

	return TRUE;
}
//===================================================================
// ʂ\
//===================================================================
static void ResultMessage( LPCTSTR lpszbuf )
{
	MessageBox( NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION );
}
//===================================================================
// G[bZ[W\
//===================================================================
static void ErrorMessage( WORD bsn )
{
	DWORD	dwRes = Apci9131wGetLastError( bsn );
	TCHAR	szbuf[ 50 ];

	switch ( dwRes ) {
		case APCI9131_ERR_WRAPDLL:
			wsprintf( szbuf, _T( "DLL Load error" ) );
			break;
		default:
			wsprintf( szbuf, _T( "aPCI-9131 error\n\n" )
							 _T( "Error code : %XH" ),
							 dwRes );
			break;
	}

	MessageBox( NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP );

	// I
	Apci9131wClose( bsn );
	Apci9131wDllClose();
}
