//===================================================================
// Apci9131s.c -- aPCI-9131 
//-------------------------------------------------------------------
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
// ̓|[g荞݂ƃ^C}荞ݎgpł
//
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#define STRICT

#include <windows.h>
#include <tchar.h>

#include "Apci9131w.h"

#define WM_APCI9131			WM_USER + 100
#define WM_APCI9131_TIMER	WM_APCI9131 + APCI9131_MSG_TIMER
#define WM_APCI9131_PORT	WM_APCI9131 + APCI9131_MSG_PORT

const TCHAR szTitle[] = _T( "Sample" );

static void ResultMessage( LPCTSTR lpszbuf );
static void ErrorMessage( WORD bsn );

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );

BOOL	OnCreate( HWND hWnd );
BOOL	OnDestroy( void );
BOOL	OnTimer( WPARAM );
BOOL	OnPortIr( WPARAM, LPARAM );
BOOL	DataShow( void );
BOOL	RegInit( void );

WORD	wBsn;
TCHAR	szBuf[ 2048 ];
BYTE	TimerCnt;
DWORD	PortIrCnt[ 8 ];
char	szClassName[] = "TvvO";

//===================================================================
// Main
//===================================================================
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
					LPSTR lpCmdLine, int nCmdShow )
{
	MSG			msg;
	WNDCLASS	wc;
	HWND		hWnd;

	//---------------------------------------------------------------
	// EChENXo^
	//---------------------------------------------------------------
	if ( !hPrevInstance ) {
		wc.style		 = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc	 = WndProc;
		wc.cbClsExtra	 = 0;
		wc.cbWndExtra	 = 0;
		wc.hInstance	 = hInstance;
		wc.hIcon		 = NULL;
		wc.hCursor		 = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = GetStockObject( WHITE_BRUSH );
		wc.lpszMenuName	 = NULL;
		wc.lpszClassName = szClassName;
		if ( !RegisterClass( &wc ) )
			return FALSE;
	}
	//---------------------------------------------------------------
	// EChE쐬
	//---------------------------------------------------------------
	hWnd = CreateWindow( szClassName,
						 szTitle,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 CW_USEDEFAULT,
						 NULL,
						 NULL,
						 hInstance,
						 NULL );

	if ( hWnd == NULL )
		return FALSE;
	//---------------------------------------------------------------
	// EChE\
	//---------------------------------------------------------------
	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );
	//---------------------------------------------------------------
	// bZ[W[v
	//---------------------------------------------------------------
	while ( GetMessage( &msg, NULL, 0, 0 ) ) {
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	return ( msg.wParam );
}
//===================================================================
// EChEbZ[W
//===================================================================
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch ( msg ) {

		case WM_SHOWWINDOW:
			OnCreate( hWnd );
			break;

		case WM_APCI9131_TIMER:
			OnTimer( wParam );
			break;

		case WM_APCI9131_PORT:
			OnPortIr( wParam, lParam );
			break;

		case WM_DESTROY:
			OnDestroy();
			PostQuitMessage( 0 );
			break;

		default:
			return( DefWindowProc( hWnd, msg, wParam, lParam ) );
	}

	return 0;
}
//===================================================================
// 
//===================================================================
BOOL OnCreate( HWND hWnd )
{
	APCI9131RESOURCE Ri;			// \[X
	DWORD			 dwDllVer;		// DLL o[W
	DWORD			 dwDrvVer;		// Driver o[W
	BYTE			 bSwVal;		// BSN l
	BYTE			 bTimer;		// ^C}荞ݎ
	int				 i;

	wBsn = APCI9131_BSN_AUTO;
	TimerCnt = 0;
	for ( i = 0; i < 8; i++ ) PortIrCnt[ i ] = 0;
	//---------------------------------------------------------------
	// DLL gp錾
	//---------------------------------------------------------------
	if ( Apci9131wDllOpen() == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;					// DLL [hs
	}
	ResultMessage( "DLL [h܂" );
	//---------------------------------------------------------------
	// o[W擾
	//---------------------------------------------------------------
	if ( Apci9131wGetVersion( &dwDllVer, &dwDrvVer ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	wsprintf( szBuf, _T( "GetVersion\n" )
					 _T( "DLL Version\t: %08XH\n" )
					 _T( "Driver Version\t: %08XH\n" ),
					 dwDllVer, dwDrvVer );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCXgp錾
	//---------------------------------------------------------------
	if ( Apci9131wCreate( &wBsn, hWnd, WM_APCI9131 ) == FALSE ) {
		ErrorMessage( APCI9131_BSN_AUTO );
		return FALSE;
	}
	ResultMessage( "aPCI-9131 Create" );
	//---------------------------------------------------------------
	// \[X BSN l擾
	//---------------------------------------------------------------
	if ( Apci9131wGetResource( wBsn, &Ri ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	if ( Apci9131wGetSwitchValue( wBsn, &bSwVal ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "APIC21 I/O Address\t: %04XH - %04XH\n" )
					 _T( "Device I/O Address\t: %04XH - %04XH\n" )
					 _T( "IRQ Number\t: %02d\n" )
					 _T( "BSN Value\t: %02XH" ),
					 Ri.dwIoBase[ 0 ], Ri.dwIoBase[ 0 ] + Ri.dwIoLength[ 0 ] - 1,
					 Ri.dwIoBase[ 1 ], Ri.dwIoBase[ 1 ] + Ri.dwIoLength[ 1 ] - 1,
					 Ri.dwIrq, bSwVal );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// eWX^ɏlݒ
	//---------------------------------------------------------------
	RegInit();
	//---------------------------------------------------------------
	// ̓|[g荞݃|eBݒ
	// SẴ|[g̓tHgJv OFFON ̕ω (オGbW) 
	// 荞ݔ
	//---------------------------------------------------------------
	if ( Apci9131wSetIrPolarity( wBsn, 0xFF ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "̓|[g荞݃|eBݒ肵܂" );
	//---------------------------------------------------------------
	// SĂ̓̓|[g荞݂Cl[u
	//---------------------------------------------------------------
	if ( Apci9131wSetPortIr( wBsn, 0xFF ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	ResultMessage( "̓|[g̊荞݂Lɂ܂" );
	//---------------------------------------------------------------
	// ^C}N (100ms)
	//---------------------------------------------------------------
	bTimer = 100;
	if ( Apci9131wSetTimer( wBsn, bTimer ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	wsprintf( szBuf, _T( "^C}N܂\n" )
					 _T( "荞ݔ : %dms" ),
					 bTimer );
	ResultMessage( szBuf );

	return TRUE;
}
//===================================================================
// I
//===================================================================
BOOL OnDestroy( void )
{
	if ( TimerCnt < 20 ) DataShow();
	//---------------------------------------------------------------
	// foCXgpJ
	//---------------------------------------------------------------
	if ( Apci9131wClose( wBsn ) == TRUE )
		ResultMessage( "aPCI-9131 Close" );
	//---------------------------------------------------------------
	// DLL gpJ
	//---------------------------------------------------------------
	if ( Apci9131wDllClose() == TRUE )
		ResultMessage( "DLL A[h܂" );

	return TRUE;
}
//===================================================================
// f[^\
//===================================================================
BOOL DataShow( void )
{
	//---------------------------------------------------------------
	// ^C}~
	//---------------------------------------------------------------
	if ( Apci9131wSetTimer( wBsn, 0x00 ) == TRUE )
		ResultMessage( "^C}荞݂𖳌ɂ܂" );
	//---------------------------------------------------------------
	// SĂ̓̓|[g荞݂fBZ[u
	//---------------------------------------------------------------
	if ( Apci9131wSetPortIr( wBsn, 0x00 ) == TRUE )
		ResultMessage( "̓|[g̊荞݂𖳌ɂ܂" );
	//---------------------------------------------------------------
	// CNgf[^\
	//---------------------------------------------------------------
	wsprintf( szBuf, _T( "^C}荞ݔ : %d\n" )
					 _T( "̓|[g1 荞ݔ : %d\n" )
					 _T( "̓|[g2 荞ݔ : %d\n" )
					 _T( "̓|[g3 荞ݔ : %d\n" )
					 _T( "̓|[g4 荞ݔ : %d\n" )
					 _T( "̓|[g5 荞ݔ : %d\n" )
					 _T( "̓|[g6 荞ݔ : %d\n" )
					 _T( "̓|[g7 荞ݔ : %d\n" )
					 _T( "̓|[g8 荞ݔ : %d\n" ),
					 TimerCnt, PortIrCnt[ 0 ], PortIrCnt[ 1 ],
					 PortIrCnt[ 2 ], PortIrCnt[ 3 ], PortIrCnt[ 4 ],
					 PortIrCnt[ 5 ], PortIrCnt[ 6 ], PortIrCnt[ 7 ] );
	ResultMessage( szBuf );

	return TRUE;
}
//===================================================================
// lݒ
//===================================================================
BOOL RegInit( void )
{
	//---------------------------------------------------------------
	// ̓|[g荞݃|eBWX^
	//---------------------------------------------------------------
	if ( Apci9131wSetIrPolarity( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// ̓|[g荞݃Cl[uWX^ (荞݋֎~)
	//---------------------------------------------------------------
	if ( Apci9131wSetPortIr( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	//---------------------------------------------------------------
	// ^C}荞 (gp)
	//---------------------------------------------------------------
	if ( Apci9131wSetTimer( wBsn, 0x00 ) == FALSE ) {
		ErrorMessage( wBsn );
		return FALSE;
	}
	
	return TRUE;
}
//===================================================================
// ^C}荞ݏ
//===================================================================
BOOL OnTimer( WPARAM wParam )
{
	//---------------------------------------------------------------
	// ^C}荞݉񐔂 20 ɂȂI
	//---------------------------------------------------------------
	if ( TimerCnt < 20 )
		TimerCnt = TimerCnt + 1;
	else
		DataShow();

	return TRUE;
}
//===================================================================
// ̓|[g荞ݏ
//===================================================================
BOOL OnPortIr( WPARAM wParam, LPARAM lParam )
{
	if ( lParam & 0x01 ) PortIrCnt[ 0 ] = PortIrCnt[ 0 ] + 1;
	if ( lParam & 0x02 ) PortIrCnt[ 1 ] = PortIrCnt[ 1 ] + 1;
	if ( lParam & 0x04 ) PortIrCnt[ 2 ] = PortIrCnt[ 2 ] + 1;
	if ( lParam & 0x08 ) PortIrCnt[ 3 ] = PortIrCnt[ 3 ] + 1;
	if ( lParam & 0x10 ) PortIrCnt[ 4 ] = PortIrCnt[ 4 ] + 1;
	if ( lParam & 0x20 ) PortIrCnt[ 5 ] = PortIrCnt[ 5 ] + 1;
	if ( lParam & 0x40 ) PortIrCnt[ 6 ] = PortIrCnt[ 6 ] + 1;
	if ( lParam & 0x80 ) PortIrCnt[ 7 ] = PortIrCnt[ 7 ] + 1;

	return TRUE;
}
//===================================================================
// ʂ\
//===================================================================
static void ResultMessage( LPCTSTR lpszbuf )
{
	MessageBox( NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION );
}
//===================================================================
// G[bZ[W\
//===================================================================
static void ErrorMessage( WORD bsn )
{
	DWORD	dwRes = Apci9131wGetLastError( bsn );
	TCHAR	szbuf[ 50 ];

	switch ( dwRes ) {
		case APCI9131_ERR_WRAPDLL:
			wsprintf( szbuf, _T( "DLL Load error" ) );
			break;
		default:
			wsprintf( szbuf, _T( "aPCI-9131 error\n\n" )
							 _T( "Error code : %XH" ),
							 dwRes );
			break;
	}

	MessageBox( NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP );

	// I
	Apci9131wClose( bsn );
	Apci9131wDllClose();
}
