//===================================================================
// Apci9131w.c -- wrapper for C/C++
//-------------------------------------------------------------------
// Copyright (C) ADTEK System Science Co., Ltd.
//===================================================================
#include <windows.h>
#include <tchar.h>

#include "Apci9131w.h"

static BOOL	   _Apci9131wGetDllExportFunc( void );
static HMODULE hDLL = NULL;

static FARPROC pApci9131GetVersion;
static FARPROC pApci9131Create;
static FARPROC pApci9131Close;
static FARPROC pApci9131GetResource;
static FARPROC pApci9131GetSwitchValue;
static FARPROC pApci9131Initialize;
static FARPROC pApci9131SetTimer;
static FARPROC pApci9131Inportb;
static FARPROC pApci9131Outportb;
static FARPROC pApci9131SetFilter;
static FARPROC pApci9131GetFilter;
static FARPROC pApci9131SetIrPolarity;
static FARPROC pApci9131GetIrPolarity;
static FARPROC pApci9131SetPortIr;
static FARPROC pApci9131GetPortIr;
static FARPROC pApci9131SetStbAckIr;
static FARPROC pApci9131GetStbAckIr;
static FARPROC pApci9131SetStbEnableRegs;
static FARPROC pApci9131GetStbEnableRegs;
static FARPROC pApci9131SetAckMode;
static FARPROC pApci9131GetAckMode;
static FARPROC pApci9131SetLedRegs;
static FARPROC pApci9131GetLedRegs;
static FARPROC pApci9131StbOut;
static FARPROC pApci9131AckOut;
static FARPROC pApci9131GetLastError;

//===================================================================
//   	DLL [h (񃍁[h̓G[Ƃ)
//   	Ȃ
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wDllOpen( void )
{
	if ( hDLL != NULL )
		return FALSE;
	hDLL = (HMODULE)LoadLibrary( APCI9131_DLL_NAME );
	if ( hDLL == NULL )
		return FALSE;
	if ( _Apci9131wGetDllExportFunc() == FALSE ) {
		Apci9131wDllClose();
		return FALSE;
	}

	return TRUE;
}
//===================================================================
//   	DLL A[h (A[h̓G[Ƃ)
//   	Ȃ
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wDllClose( void )
{
	if ( hDLL == NULL )
		return FALSE;
	if ( FreeLibrary( hDLL ) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}

	return FALSE;
}
//===================================================================
//   	DLLADriver ̃o[W擾
//   	pdwDllVersion	DLL o[Wԍi[̈
// @@@	pdwDrvVersion	Driver o[Wԍi[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetVersion)( pdwDllVersion, pdwDrvVersion );
}
//===================================================================
//   	foCXgp錾
//   	pwBsn	gpfoCX BSN li[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wCreate( PWORD pwBsn, HWND hWnd, UINT uWMBase )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131Create)( pwBsn, hWnd, uWMBase );
}
//===================================================================
//   	foCXJ
//   	wBsn	foCX BSN l
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wClose( WORD wBsn )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131Close)( wBsn );
}
//===================================================================
//   	\[X擾
//   	wBsn	foCX BSN l
// @@@	pRes	\[Xi[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetResource( WORD wBsn, PAPCI9131R pRes )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetResource)( wBsn, pRes );
}
//===================================================================
//   	BSN l擾
//   	wBsn	foCX BSN l
// @@@	pbValue	BSN li[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetSwitchValue( WORD wBsn, PBYTE pbValue )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetSwitchValue)( wBsn, pbValue );
}
//===================================================================
//   	foCX
//   	wBsn	foCX BSN l
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wInitialize( WORD wBsn )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131Initialize)( wBsn );
}
//===================================================================
//   	^C}ݒ
//   	wBsn	foCX BSN l
// @@@	dwCount	^C}荞ݔ
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetTimer( WORD wBsn, DWORD dwCount )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetTimer)( wBsn, dwCount );
}
//===================================================================
//   	|[g
//   	wBsn	foCX BSN l
// @@@	dwPort	̓|[gԍ
// @@@	pData	͒li[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wInportb( WORD wBsn, DWORD dwPort, PBYTE pData )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131Inportb)( wBsn, dwPort, pData );
}
//===================================================================
//   	|[go
//   	wBsn	foCX BSN l
// @@@	dwPort	o̓|[gԍ
// @@@	Data	o͒l
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wOutportb( WORD wBsn, DWORD dwPort, BYTE Data )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131Outportb)( wBsn, dwPort, Data );
}
//===================================================================
//   	̓|[g/STB_IN/ACK_IN tB^^Cݒ
//   	wBsn	foCX BSN l
// @@@	dwPort	ݒΏۂ̃|[gԍ
// @@@	Cnt		JE^ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetFilter( WORD wBsn, DWORD dwPort, BYTE Cnt )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetFilter)( wBsn, dwPort, Cnt );
}
//===================================================================
//   	̓|[g/STB_IN/ACK_IN tB^^Cݒl擾
//   	wBsn	foCX BSN l
// @@@	dwPort	ݒΏۂ̃|[gԍ
// @@@	pCnt	JE^ݒli[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetFilter( WORD wBsn, DWORD dwPort, PBYTE pCnt )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetFilter)( wBsn, dwPort, pCnt );
}
//===================================================================
//   	荞݃|eBݒ
//   	wBsn	foCX BSN l
// @@@	Pol		͊荞݃|eBWX^ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetIrPolarity( WORD wBsn, BYTE Pol )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetIrPolarity)( wBsn, Pol );
}
//===================================================================
//   	荞݃|eBWX^ݒl擾
//   	wBsn	foCX BSN l
// @@@	pPol	͊荞݃|eBWX^ݒli[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetIrPolarity( WORD wBsn, PBYTE pPol )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetIrPolarity)( wBsn, pPol );
}
//===================================================================
//   	̓|[g荞ݐݒ
//   	wBsn	foCX BSN l
// @@@	Ir		荞݃Cl[uWX^ (̓|[g) ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetPortIr( WORD wBsn, BYTE Ir )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetPortIr)( wBsn, Ir );
}
//===================================================================
//   	̓|[g荞ݐݒl擾
//   	wBsn	foCX BSN l
// @@@	pIr		荞݃Cl[uWX^ (̓|[g) ݒl
// @@@			i[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetPortIr( WORD wBsn, PBYTE pIr )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetPortIr)( wBsn, pIr );
}
//===================================================================
//   	STB/ACK 荞ݐݒ
//   	wBsn	foCX BSN l
// @@@	Ir		荞݃Cl[uWX^ (STB/ACK) ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetStbAckIr( WORD wBsn, BYTE Ir )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetStbAckIr)( wBsn, Ir );
}
//===================================================================
//   	STB/ACK 荞ݐݒl擾
//   	wBsn	foCX BSN l
// @@@	pIr		荞݃Cl[uWX^ (STB/ACK) ݒl
// @@@			i[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetStbAckIr( WORD wBsn, PBYTE pIr )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetStbAckIr)( wBsn, pIr );
}
//===================================================================
//   	STB_IN Cl[uWX^ݒ
//   	wBsn	foCX BSN l
// @@@	Sen		STB_IN Cl[uWX^ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetStbEnableRegs( WORD wBsn, BYTE Sen )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetStbEnableRegs)( wBsn, Sen );
}
//===================================================================
//   	STB_IN Cl[uWX^ݒl擾
//   	wBsn	foCX BSN l
// @@@	pSen	STB_IN Cl[uWX^ݒli[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetStbEnableRegs( WORD wBsn, PBYTE pSen )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetStbEnableRegs)( wBsn, pSen );
}
//===================================================================
//   	ACK/RDY [hWX^ݒ
//   	wBsn	foCX BSN l
// @@@	Ackm	ACK/BUSY [hWX^ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetAckMode( WORD wBsn, BYTE Ackm )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetAckMode)( wBsn, Ackm );
}
//===================================================================
//   	ACK/RDY [hWX^ݒl擾
//   	wBsn	foCX BSN l
// @@@	pAckm	ACK/BUSY [hWX^ݒli[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetAckMode( WORD wBsn, PBYTE pAckm )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetAckMode)( wBsn, pAckm );
}
//===================================================================
//   	LED 䃌WX^ݒ
//   	wBsn	foCX BSN l
// @@@	Led		LED 䃌WX^ݒl
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wSetLedRegs( WORD wBsn, BYTE Led )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131SetLedRegs)( wBsn, Led );
}
//===================================================================
//   	LED 䃌WX^ݒl擾
//   	wBsn	foCX BSN l
// @@@	pLed	LED 䃌WX^ݒli[̈
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wGetLedRegs( WORD wBsn, PBYTE pLed )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131GetLedRegs)( wBsn, pLed );
}
//===================================================================
//   	STB o
//   	wBsn	foCX BSN l
// @@@	Stb		STB o͒l
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wStbOut( WORD wBsn, BYTE Stb )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131StbOut)( wBsn, Stb );
}
//===================================================================
//   	ACK o
//   	wBsn	foCX BSN l
// @@@	Ack		ACK o͒l
// ߂l		TRUE
// @@@	s	FALSE
//===================================================================
BOOL Apci9131wAckOut( WORD wBsn, BYTE Ack )
{
	if ( hDLL == NULL )
		return FALSE;

	return (*pApci9131AckOut)( wBsn, Ack );
}
//===================================================================
//   	G[擾
//   	wBsn	foCX BSN l
// ߂l	G[
//===================================================================
DWORD Apci9131wGetLastError( WORD wBsn )
{
	if ( hDLL == NULL )
		return APCI9131_ERR_WRAPDLL;

	return (*pApci9131GetLastError)( wBsn );
}
//-------------------------------------------------------------------
//   	GNX|[g֐AhX̎擾
//   	Ȃ
// ߂l		TRUE
// @@@	s	FALSE
//-------------------------------------------------------------------
static BOOL _Apci9131wGetDllExportFunc( void )
{
	pApci9131GetVersion		  = GetProcAddress( hDLL, _T( "Apci9131GetVersion" ) );
	pApci9131Create			  = GetProcAddress( hDLL, _T( "Apci9131Create" ) );
	pApci9131Close			  = GetProcAddress( hDLL, _T( "Apci9131Close" ) );
	pApci9131GetResource	  = GetProcAddress( hDLL, _T( "Apci9131GetResource" ) );
	pApci9131GetSwitchValue	  = GetProcAddress( hDLL, _T( "Apci9131GetSwitchValue" ) );
	pApci9131Initialize		  = GetProcAddress( hDLL, _T( "Apci9131Initialize" ) );
	pApci9131SetTimer		  = GetProcAddress( hDLL, _T( "Apci9131SetTimer" ) );
	pApci9131Inportb		  = GetProcAddress( hDLL, _T( "Apci9131Inportb" ) );
	pApci9131Outportb		  = GetProcAddress( hDLL, _T( "Apci9131Outportb" ) );
	pApci9131SetFilter		  = GetProcAddress( hDLL, _T( "Apci9131SetFilter" ) );
	pApci9131GetFilter		  = GetProcAddress( hDLL, _T( "Apci9131GetFilter" ) );
	pApci9131SetIrPolarity	  = GetProcAddress( hDLL, _T( "Apci9131SetIrPolarity" ) );
	pApci9131GetIrPolarity	  = GetProcAddress( hDLL, _T( "Apci9131GetIrPolarity" ) );
	pApci9131SetPortIr		  = GetProcAddress( hDLL, _T( "Apci9131SetPortIr" ) );
	pApci9131GetPortIr		  = GetProcAddress( hDLL, _T( "Apci9131GetPortIr" ) );
	pApci9131SetStbAckIr	  = GetProcAddress( hDLL, _T( "Apci9131SetStbAckIr" ) );
	pApci9131GetStbAckIr	  = GetProcAddress( hDLL, _T( "Apci9131GetStbAckIr" ) );
	pApci9131SetStbEnableRegs = GetProcAddress( hDLL, _T( "Apci9131SetStbEnableRegs" ) );
	pApci9131GetStbEnableRegs = GetProcAddress( hDLL, _T( "Apci9131GetStbEnableRegs" ) );
	pApci9131SetAckMode		  = GetProcAddress( hDLL, _T( "Apci9131SetAckMode" ) );
	pApci9131GetAckMode		  = GetProcAddress( hDLL, _T( "Apci9131GetAckMode" ) );
	pApci9131SetLedRegs		  = GetProcAddress( hDLL, _T( "Apci9131SetLedRegs" ) );
	pApci9131GetLedRegs		  = GetProcAddress( hDLL, _T( "Apci9131GetLedRegs" ) );
	pApci9131StbOut			  = GetProcAddress( hDLL, _T( "Apci9131StbOut" ) );
	pApci9131AckOut			  = GetProcAddress( hDLL, _T( "Apci9131AckOut" ) );
	pApci9131GetLastError	  = GetProcAddress( hDLL, _T( "Apci9131GetLastError" ) );

	if ( pApci9131GetVersion == NULL )		 return FALSE;
	if ( pApci9131Create == NULL )			 return FALSE;
	if ( pApci9131Close == NULL )			 return FALSE;
	if ( pApci9131GetResource == NULL )		 return FALSE;
	if ( pApci9131GetSwitchValue == NULL )	 return FALSE;
	if ( pApci9131Initialize == NULL )		 return FALSE;
	if ( pApci9131SetTimer == NULL )		 return FALSE;
	if ( pApci9131Inportb == NULL )			 return FALSE;
	if ( pApci9131Outportb == NULL )		 return FALSE;
	if ( pApci9131SetFilter == NULL )		 return FALSE;
	if ( pApci9131GetFilter == NULL )		 return FALSE;
	if ( pApci9131SetIrPolarity == NULL )	 return FALSE;
	if ( pApci9131GetIrPolarity == NULL )	 return FALSE;
	if ( pApci9131SetPortIr == NULL )		 return FALSE;
	if ( pApci9131GetPortIr == NULL )		 return FALSE;
	if ( pApci9131SetStbAckIr == NULL )		 return FALSE;
	if ( pApci9131GetStbAckIr == NULL )		 return FALSE;
	if ( pApci9131SetStbEnableRegs == NULL ) return FALSE;
	if ( pApci9131GetStbEnableRegs == NULL ) return FALSE;
	if ( pApci9131SetAckMode == NULL )		 return FALSE;
	if ( pApci9131GetAckMode == NULL )		 return FALSE;
	if ( pApci9131SetLedRegs == NULL )		 return FALSE;
	if ( pApci9131GetLedRegs == NULL )		 return FALSE;
	if ( pApci9131StbOut == NULL )			 return FALSE;
	if ( pApci9131AckOut == NULL )			 return FALSE;
	if ( pApci9131GetLastError == NULL )	 return FALSE;

	// ׂĂ DLL GNX|[g֐AhX擾 OK
	return TRUE;
}
